<?php
/*******************************************************************************
 *
 * CoreModOverview.php - Core Overview module to handle ajax requests
 *
 * Copyright (c) 2004-2010 NagVis Project (Contact: info@nagvis.org)
 *
 * License:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 ******************************************************************************/

/**
 * @author Lars Michelsen <lars@vertical-visions.de>
 */
class CoreModOverview extends CoreModule {
	private $BACKEND = null;
	private $OVERVIEW = null;
	
	public function __construct(GlobalCore $CORE) {
		$this->sName = 'Overview';
		$this->CORE = $CORE;
		
		$this->aActions = Array(
			'getOverviewProperties' => 'view',
			'getOverviewMaps'       => 'view',
			'getOverviewAutomaps'   => 'view',
			'getOverviewRotations'  => 'view'
		);
	}
	
	public function handleAction() {
		$sReturn = '';
		
		if($this->offersAction($this->sAction)) {
			$this->BACKEND = new CoreBackendMgmt($this->CORE);
			$this->OVERVIEW = new GlobalIndexPage($this->CORE, $this->BACKEND, $this->AUTHORISATION);
			
			switch($this->sAction) {
				case 'getOverviewProperties':
					$sReturn = $this->OVERVIEW->parseIndexPropertiesJson();
				break;
				case 'getOverviewMaps':
					$sReturn = $this->OVERVIEW->parseMapsJson('map');
				break;
				case 'getOverviewAutomaps':
					$sReturn = $this->OVERVIEW->parseMapsJson('automap');
				break;
				case 'getOverviewRotations':
					$sReturn = $this->OVERVIEW->parseRotationsJson();
				break;
			}
		}
		
		return $sReturn;
	}
}
?>
